<bugID>1203602<Summary>[e10s] Closing tab during &#8220;Save As&#8230; Complete Document&#8221;&#160;saves partial/empty document</Summary><Description>Part of the cause of bug 1202887 is that closing a tab while a persistence operation is in progress will immediately destroy the PBrowser actor and all its descendents, including any PWebBrowserPersistDocument actors, thus leaving a partially completed save.

This is almost certainly not what the user expects, and also doesn't match the non-e10s behavior where holding a reference to the document is enough to keep it alive.

But it's worse than that: a parent-&gt;child message can be sent on the PWebBrowserPersistDocument concurrently with the child-&gt;parent PBrowser::__delete__, which results in one of these:

###!!! [Child][DispatchAsyncMessage] Error: (msgtype=0xE60003,name=???) Route error: message sent to unknown actor ID

Which crashes the content process.  (For reference, 0xE60003 is PWebBrowserPersistDocument::SetPersistFlags.)  There are probably already some of these on crash-stats, but I don't know if there's enough info in the dump to distinguish them from other child-side MsgRouteError crashes.

So this needs a way of keeping the TabChild alive until persistence is finished.</Description></bugID>